package cz.cuni.attackbot;

import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.Param;
import cz.cuni.amis.pogamut.sposh.executor.ParamsAction;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.FlagInfo;
import cz.cuni.amis.pogamut.ut2004.examples.attackbot.AttackBotContext;

/**
 * Do adrenaline combo of input type.
 *
 * @author knight
 */
@PrimitiveInfo(name="AdrenalineCombo", description="Do adrenaline combo of input $type ($type can be \"berserk\", \"defensive\", \"invis\", \"speed\"). You can do the combo only with adrenaline at 100!")
public class AdrenalineCombo extends ParamsAction<AttackBotContext> {

    public AdrenalineCombo(AttackBotContext ctx) {
        super(ctx);
    }

    public void init(@Param("$type") String type) {
        if (type.contentEquals("berserk")) {
            ctx.getBody().getAction().startCombo("xGame.ComboBerserk");
        } else if (type.contentEquals("defensive")) {
            ctx.getBody().getAction().startCombo("xGame.ComboDefensive");
        } else if (type.contentEquals("invis")) {
            ctx.getBody().getAction().startCombo("xGame.ComboInvis");
        } else if (type.contentEquals("speed")) {
            ctx.getBody().getAction().startCombo("xGame.ComboSpeed");
        }                                
    }

    public ActionResult run() {
        return ActionResult.RUNNING_ONCE;        
    }

    public void done() {
        
    }
}
